/*
 * Aipo is a groupware program developed by Aimluck,Inc.
 * Copyright (C) 2004-2008 Aimluck,Inc.
 * http://aipostyle.com/
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package com.aimluck.commons.field;

import java.io.Serializable;

/**
 * 入力フィールドを表す抽象クラスです。 <br />
 * 
 */
public abstract class ALAbstractField implements Serializable {

  /** 入力文字の文字コード判別用に利用する文字コード */
  protected static final String ENCORDE_CONFIRM_CHARTYPE = "shift_jis";

  /** Nullフラグ */
  protected boolean notNull = false;

  /** 入力フィールド名 */
  protected String fieldName = null;

  /**
   * コンストラクタ
   * 
   */
  public ALAbstractField() {
  }

  /**
   * Nullフラグを設定します。
   * 
   * @param bool
   *            Nullフラグ
   */
  public void setNotNull(boolean bool) {
    notNull = bool;
  }

  /**
   * 入力フィールドがNullかどうかを取得します。
   * 
   * @return
   */
  public boolean isNotNull() {
    return notNull;
  }

  /**
   * 入力フィールド名を設定します。
   * 
   * @param str
   */
  public void setFieldName(String str) {
    fieldName = str;
  }

  /**
   * 入力フィールド名を取得します。
   * 
   * @return
   */
  public String getFieldName() {
    return fieldName;
  }

  /**
   * 入力フィールドに値を設定します。
   * 
   * @param str
   */
  public abstract void setValue(String str);

}
