/*
 * Copyright 2000-2001,2004 The Apache Software Foundation.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.jetspeed.tutorial.portal.portlets;

import org.apache.jetspeed.portal.portlets.AbstractInstancePortlet;
import org.apache.turbine.util.RunData;
import org.apache.turbine.util.Log;
import org.apache.jetspeed.services.rundata.JetspeedRunData;

import org.apache.jetspeed.om.security.JetspeedUser;
import org.apache.ecs.ConcreteElement;
import org.apache.ecs.StringElement;

import org.apache.jetspeed.services.JetspeedUserManagement;
import org.apache.jetspeed.services.security.JetspeedSecurityException;

/**
 * Introduction to the Portlet interface + the User 
 *
 * @author <a href="mailto:taylor@apache.org">David Sean Taylor</a>
 * @version $Id: HelloUserPortlet.java,v 1.1 2004/04/08 17:03:54 taylor Exp $
 */
public class HelloUserPortlet extends AbstractInstancePortlet
{
    public ConcreteElement getContent(RunData runData)
    {
        StringBuffer text =new StringBuffer();

        text.append("Hello ");

        String name = runData.getUser().getFirstName();

        if (name == null)
            name ="Anonymous";

        text.append (name);
        text.append ("!");
        return (new StringElement(text.toString()));
    }

    public void ExampleOfDisablingUser(JetspeedRunData rundata)
    {
        try
        {
            JetspeedUser user = user = rundata.getJetspeedUser();
            user.setDisabled(true);
            JetspeedUserManagement.saveUser(user);
        }
        catch (JetspeedSecurityException e)
        {
            Log.error("failed to save user", e);
        }

    }
}

